package com.jose.businessclients;

import android.os.Bundle;
import android.app.Activity;
import android.app.AlertDialog;
import android.database.Cursor;
import android.view.Window;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.AdapterView;
import android.widget.Toast;
import android.view.View;
import java.util.ArrayList;
import java.util.Collections;

import android.content.DialogInterface;
import android.content.Intent;
import android.widget.TextView;

public class EditarContacto extends Activity {

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		//configurar barra de titulo
		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		setContentView(R.layout.activity_editar_contacto);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.barratitulo_editar_contacto);
		//configurar spinners
		Spinner tipo_movil = (Spinner) findViewById(R.id.campo_tipo);
		ArrayAdapter<CharSequence> adapter_movil = ArrayAdapter.createFromResource(this, R.array.tipos_movil, android.R.layout.simple_spinner_item);
		adapter_movil.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		tipo_movil.setAdapter(adapter_movil);
		tipo_movil.setOnItemSelectedListener(new OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
				
			}
			
			public void onNothingSelected(AdapterView<?> parentView) {
				
			}
		});
		Spinner tipo_provincia = (Spinner) findViewById(R.id.campo_provincia);
		ArrayAdapter<CharSequence> adapter_provincia = ArrayAdapter.createFromResource(this, R.array.tipos_provincia, android.R.layout.simple_spinner_item);
		adapter_provincia.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		tipo_provincia.setAdapter(adapter_provincia);
		tipo_provincia.setOnItemSelectedListener(new OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
				
			}
			
			public void onNothingSelected(AdapterView<?> parentView) {
				
			}
		});
		final ArrayList<String> groups = new ArrayList<String>();
		BDAdaptor bda = new BDAdaptor(this);
		bda.abrir_escritura();
		Cursor micursor = bda.obtenerGrupos();
        if (micursor.moveToFirst())
        {
        do {
        groups.add(micursor.getString(0));
        } while (micursor.moveToNext());
        }
        groups.add(0, "Sin grupo");
        groups.add("Nuevo grupo");
        bda.cerrar();
		final Spinner tipo_grupo = (Spinner) findViewById(R.id.campo_grupo);
		@SuppressWarnings({ "unchecked", "rawtypes" })
		ArrayAdapter<CharSequence> adapter_grupo = new ArrayAdapter(this, android.R.layout.simple_spinner_item, groups);
		adapter_grupo.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		tipo_grupo.setAdapter(adapter_grupo);
		//declarar textviews
		TextView nombre = (TextView) findViewById(R.id.campo_nombre);
		TextView empresa  = (TextView) findViewById(R.id.campo_empresa);
		TextView direccion = (TextView) findViewById(R.id.campo_direccion);
		TextView email = (TextView) findViewById(R.id.campo_email);
		TextView web = (TextView) findViewById(R.id.campo_web);
		TextView telefono = (TextView) findViewById(R.id.campo_telefono);
		TextView ciudad = (TextView) findViewById(R.id.campo_ciudad);
		Bundle bundle = getIntent().getExtras();
		String contacto = bundle.getString("contacto");
		//obtener datos de contacto
		bda.abrir_escritura();
		Cursor cursorContacto = bda.obtenerContacto(contacto);
		if(cursorContacto.moveToFirst()) {
			nombre.setText(cursorContacto.getString(0));
			empresa.setText(cursorContacto.getString(2));
			ciudad.setText(cursorContacto.getString(4));
			direccion.setText(cursorContacto.getString(5));
			email.setText(cursorContacto.getString(6));
			web.setText(cursorContacto.getString(7));
			if(cursorContacto.getString(1).isEmpty()) {
				tipo_grupo.setSelection(0);
			} else {
				tipo_grupo.setSelection(groups.indexOf(cursorContacto.getString(1)));
			}
			String[] lista_temporal = getResources().getStringArray(R.array.tipos_provincia);
			ArrayList<String> list = new ArrayList<String>();
			for (int i = 0;i<lista_temporal.length;i++) {
				list.add(lista_temporal[i]);
			}
			tipo_provincia.setSelection(list.indexOf(cursorContacto.getString(3)));
		}
		final String seleccion = cursorContacto.getString(1);
		//comportamiento spinner grupo
		tipo_grupo.setOnItemSelectedListener(new OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
				if(position == groups.size()-1) {
					onCreateDialog(selectedItemView, groups, seleccion);
				}
			}
			
			public void onNothingSelected(AdapterView<?> parentView) {
				
			}
		});
		//obtener telefono contacto
		Cursor cursorTelefono = bda.obtenerTelefono(contacto);
		if(cursorTelefono.moveToFirst()) {
			telefono.setText(cursorTelefono.getString(1));
			String[] lista_temporal2 = getResources().getStringArray(R.array.tipos_movil);
			ArrayList<String> lista = new ArrayList<String>();
			for(int i = 0;i<lista_temporal2.length;i++) {
				lista.add(lista_temporal2[i]);
			}
			tipo_movil.setSelection(lista.indexOf(cursorContacto.getString(2)));
		}
		bda.cerrar();
	}
	
	//boton volver a a la lista
	 public boolean volverALista(View v) {
		 BDAdaptor bda = new BDAdaptor(this);
		 bda.abrir_escritura();
		 Cursor miCursor = bda.obtenerInicio();
		 int inicio = 0;
		 if(miCursor.moveToFirst()) {
			 inicio = Integer.parseInt(miCursor.getString(0));
		 }
		 bda.cerrar();
		 Intent act;
		 if(inicio == 0) {
			 act = new Intent(this, ListaAlfabetica.class);
			 startActivity(act);
		 } else if(inicio == 1) {
			 act = new Intent(this, ListaGrupos.class);
			 startActivity(act);
		 }
		 return true;
	 }
	 
	 //boton guardar contacto
	 public boolean guardarContacto(View v) {
		 
		 Bundle bundle = getIntent().getExtras();
		 Spinner tipo_movil = (Spinner) findViewById(R.id.campo_tipo);
		 Spinner tipo_provincia = (Spinner) findViewById(R.id.campo_provincia);
		 Spinner tipo_grupo = (Spinner) findViewById(R.id.campo_grupo);
		 TextView nombre = (TextView) findViewById(R.id.campo_nombre);
		 TextView empresa  = (TextView) findViewById(R.id.campo_empresa);
		 TextView direccion = (TextView) findViewById(R.id.campo_direccion);
		 TextView email = (TextView) findViewById(R.id.campo_email);
		 TextView web = (TextView) findViewById(R.id.campo_web);
		 TextView telefono = (TextView) findViewById(R.id.campo_telefono);
		 TextView ciudad = (TextView) findViewById(R.id.campo_ciudad);
		 String contacto = bundle.getString("contacto");
		 if(nombre.getText().toString().equals("")) {
			 Toast.makeText(getApplicationContext(), "Es necesario indicar un nombre de usuario", Toast.LENGTH_LONG).show();
			 return false;
		 }
		 BDAdaptor bda = new BDAdaptor(this);
		 bda.abrir_escritura();
		 bda.actualizarContacto(contacto, nombre.getText().toString(), tipo_grupo.getSelectedItem().toString(), empresa.getText().toString(), tipo_provincia.getSelectedItem().toString(), ciudad.getText().toString(), direccion.getText().toString(), email.getText().toString(), web.getText().toString());
		 bda.actualizarTelefono(contacto, nombre.getText().toString(), telefono.getText().toString(), tipo_movil.getSelectedItem().toString());
		 bda.cerrar();
		 bda.abrir_escritura();
		 Cursor miCursor = bda.obtenerInicio();
		 int inicio = 0;
		 if(miCursor.moveToFirst()) {
			 inicio = Integer.parseInt(miCursor.getString(0));
		 }
		 bda.cerrar();
		 Intent act;
		 if(inicio == 0) {
			 act = new Intent(this, ListaAlfabetica.class);
			 startActivity(act);
		 } else if(inicio == 1) {
			 act = new Intent(this, ListaGrupos.class);
			 startActivity(act);
		 }
		 return true;
	 }
	 
	 //Dialogo de nuevo grupo
	 protected void onCreateDialog(final View v, final ArrayList<String> groups, final String anterior_seleccion) {
		 final EditText textoGrupo = new EditText(this);
	    	AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
	    	alertDialogBuilder.setView(textoGrupo);
	    	alertDialogBuilder.setTitle("Nuevo grupo");
	    	alertDialogBuilder
	    	.setCancelable(false)
	    	.setPositiveButton("OK", new DialogInterface.OnClickListener() {
	    	public void onClick(DialogInterface dialog,int id) {
	    		String grupo = textoGrupo.getText().toString();
	    		if(existeGrupo(grupo, groups)) {
	    			Toast toast = Toast.makeText(v.getContext(), "El grupo indicado ya existe.", Toast.LENGTH_LONG);
	    	        toast.show();
	    	        onCreateDialog(v, groups, anterior_seleccion);
	    		}
	    		else if (grupo.isEmpty()) {
	    			Toast toast = Toast.makeText(v.getContext(), "Debes indicar el nombre del grupo.", Toast.LENGTH_LONG);
	    	        toast.show();
	    	        onCreateDialog(v, groups, anterior_seleccion);
	    		}
	    		else {
		    		BDAdaptor bda = new BDAdaptor(v.getContext());
		    		bda.abrir_escritura();  
		    		bda.insertarGrupo(textoGrupo.getText().toString());
		    		groups.add(textoGrupo.getText().toString());
		    		Spinner tipo_grupo = (Spinner) findViewById(R.id.campo_grupo);
		    		bda.cerrar();
		    		groups.remove("Sin grupo");
					groups.remove("Nuevo grupo");
					Collections.sort(groups);
					groups.add(0, "Sin grupo");
					groups.add("Nuevo grupo");
					dialog.cancel();
					tipo_grupo.setSelection(groups.indexOf(textoGrupo.getText().toString()));
					BaseAdapter la = (BaseAdapter) tipo_grupo.getAdapter();
					la.notifyDataSetChanged();
					
	    		}
	    	}
	    	})
	    	.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
	    	public void onClick(DialogInterface dialog,int id) {
	    	Spinner tipo_grupo = (Spinner) findViewById(R.id.campo_grupo);
	    	dialog.cancel();
	    	tipo_grupo.setSelection(groups.indexOf(anterior_seleccion));
	    	BaseAdapter la = (BaseAdapter) tipo_grupo.getAdapter();
			la.notifyDataSetChanged();
	    	}
	    	});
	     
	        alertDialogBuilder.create().show();
	    }
	 
	 //comprovar si existe un grupo
	 private boolean existeGrupo(String grupo, ArrayList<String> groups) {
		 for(int i = 0; i < groups.size(); i++) {
	    		if(grupo.equals(groups.get(i).toString())) {
	    			return true;
	    		}
	    	}
	    	return false;
	 }

}
