package com.jose.businessclients;

import android.view.View;
import android.database.Cursor;

import java.util.ArrayList;
import java.util.Collections;

import android.widget.BaseExpandableListAdapter;
import android.content.Context;
import android.view.ViewGroup;
import android.widget.TextView;

public class ExpandableListAdaptor extends BaseExpandableListAdapter {

	    private Context context;
	    private ArrayList<String> groups = new ArrayList<String>();
	    private ArrayList<ArrayList<String>> childrens = new ArrayList<ArrayList<String>>();
	    private int numgroups;
	    
	    //constructor
	    public ExpandableListAdaptor(Context context, ArrayList<String> groups, Cursor clients) {
	        this.context = context;
	        this.groups = groups;
	        this.groups.add("Sin grupo");
	        this.numgroups = groups.size();
	        ArrayList<String> auxiliar = new ArrayList<String>();
	        String temporal = "";
	        for (int i = 0; i < this.numgroups - 1; i++) {
	        	auxiliar = new ArrayList<String>();
	        	if(clients.moveToFirst()) {
	        		do {
	        			temporal = clients.getString(1);
	        			if(temporal.equals(this.groups.get(i))) {
	        				auxiliar.add(clients.getString(0));
	        			}
	        		} while (clients.moveToNext());
	        	}
	        	
	        	childrens.add(i,auxiliar);
	        }
	        if(clients.moveToFirst()) {
	        	auxiliar = new ArrayList<String>();
        		do {
        			temporal = clients.getString(1);
        			if(temporal.equals("Sin grupo")) {
        				auxiliar.add(clients.getString(0));
        			}
        		} while (clients.moveToNext());
        	}
	        
	        childrens.add(this.groups.size()-1, auxiliar);
	        
	        
	    }
	    
		 @Override
		 public boolean areAllItemsEnabled()
		 {
		    return true;
		 }

	    @Override
	    public String getChild(int groupPosition, int childPosition) {
	        return childrens.get(groupPosition).get(childPosition);
	    }


	    @Override
	    public long getChildId(int groupPosition, int childPosition) {
	        return childPosition;
	    }
	    

	    
	    @Override
	    public View getChildView(int groupPosition, int childPosition, boolean isLastChild,
	            View convertView, ViewGroup parent) {
	    	//vista hijo
	    	View inflate = View.inflate(this.context, R.layout.hijo, null);
	        TextView tv = (TextView) inflate.findViewById(R.id.text_hijo);
	        tv.setText(getChild(groupPosition, childPosition).toString());
	        return inflate;
	    }

	    @Override
	    public int getChildrenCount(int groupPosition) {
	        return childrens.get(groupPosition).size();
	    }


	    @Override
	    public Object getGroup(int groupPosition) {
	        return groups.get(groupPosition);
	    }


	    @Override
	    public int getGroupCount() {
	        return groups.size();
	    }


	    @Override
	    public long getGroupId(int groupPosition) {
	        return groupPosition;
	    }

	    @Override
	    public View getGroupView(int groupPosition, boolean isExpanded, View convertView,
	            ViewGroup parent) {
	    	//vista padre
	    	View inflate = View.inflate(this.context, R.layout.padre, null);
	        TextView tv = (TextView) inflate.findViewById(R.id.text_padre);
	        tv.setText(getGroup(groupPosition).toString());
	        inflate.setTag("patata");
	        return inflate;
	    }


	    @Override
	    public boolean hasStableIds() {
	        return true;
	    }


	    @Override
	    public boolean isChildSelectable(int arg0, int arg1) {
	        return true;
	    }
	    
	    
	    
	    public void eliminarCliente(int idGrupo, String contacto) {
	    	childrens.get(idGrupo).remove(contacto);
	    }
	    
	   
	    
	    
	    

}
