package com.jose.businessclients;

import java.util.ArrayList;
import java.util.Collections;

import android.os.Bundle;
import android.app.Dialog;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.view.ContextMenu.ContextMenuInfo;
import android.app.AlertDialog;
import android.content.DialogInterface;
import 	android.widget.EditText;
import android.widget.Toast;
import android.widget.BaseAdapter;
import android.widget.AdapterView.AdapterContextMenuInfo;

public class GestionGrupos extends ListActivity {
	
	private ArrayList<String> resultado = new ArrayList<String>();

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		BDAdaptor bda = new BDAdaptor(this);
		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		bda.abrir_escritura();
		//consultar grupos
	    Cursor micursor = bda.obtenerGrupos();
	    if (micursor.moveToFirst())
	    {
	    	do {
	    		resultado.add(micursor.getString(0));
	    	} while (micursor.moveToNext());
	    }
	    Collections.sort(resultado);
	    setListAdapter(new ArrayAdapter<String>(this,
	                android.R.layout.simple_list_item_1, resultado));
	    
	    getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.barratitulo_gestionar_grupos);
	    bda.cerrar();
	    ListView lv = this.getListView();
	    registerForContextMenu(lv);
	    
	}
	
	//menu contextual
    public void onCreateContextMenu(ContextMenu menu, View view,
			ContextMenuInfo menuInfo) {
		super.onCreateContextMenu(menu, view, menuInfo);
		AdapterContextMenuInfo info = (AdapterContextMenuInfo)menuInfo;
		String seleccionado = this.getListView().getAdapter().getItem(info.position).toString();
		menu.setHeaderTitle(seleccionado);
		CreateContextMenu(menu);
	}
    
    //crear menu contextual
    private void CreateContextMenu(Menu menu) {
    	menu.add(0,0,0, "Editar grupo");
    	menu.add(0,1,1, "Borrar grupo");
    }
    
    //accion al seleccionar elemento menu contextual
    public boolean onContextItemSelected(final MenuItem item) {
        AdapterContextMenuInfo info = (AdapterContextMenuInfo) item.getMenuInfo();
        final String seleccionado = this.getListView().getAdapter().getItem(info.position).toString();
        switch (item.getItemId()) {
             case 0:
            	final EditText textoGrupo = new EditText(this);
            	textoGrupo.setText(seleccionado);
             	AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
             	alertDialogBuilder.setView(textoGrupo);
             	alertDialogBuilder.setTitle("Nuevo grupo");
             	final ListView list = this.getListView();
             	final BaseAdapter la = (BaseAdapter) list.getAdapter();
             	alertDialogBuilder
             	.setCancelable(false)
             	.setPositiveButton("OK", new DialogInterface.OnClickListener() {
             	public void onClick(DialogInterface dialog,int id) {
             		String grupo = textoGrupo.getText().toString();
             		if(existeGrupo(grupo)) {
             			Toast toast = Toast.makeText(list.getContext(), "El grupo indicado ya existe.", Toast.LENGTH_LONG);
             	        toast.show();
             	        onContextItemSelected(item);
             		}
             		else if (grupo.isEmpty()) {
             			Toast toast = Toast.makeText(list.getContext(), "Debes indicar el nombre del grupo.", Toast.LENGTH_LONG);
             	        toast.show();
             	        onContextItemSelected(item);
             		}
             		else {
         	    		BDAdaptor bda = new BDAdaptor(list.getContext());
         	    		bda.abrir_escritura();  
         	    		bda.modificarGrupo(seleccionado, textoGrupo.getText().toString());
         	    		resultado.remove(seleccionado);
         	    		resultado.add(textoGrupo.getText().toString());
         	    		Collections.sort(resultado);
         	        	la.notifyDataSetChanged();
         	    		bda.cerrar();
             		}
             	}
             	})
             	.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
             	public void onClick(DialogInterface dialog,int id) {
             	dialog.cancel();
             	}
             	});
             	 
             	AlertDialog alertDialog = alertDialogBuilder.create();
             	alertDialog.show();
                   return true;
             case 1:
                   onCreateDialog(seleccionado,this).show();
                   return true;
             default:
            	   return super.onContextItemSelected(item);
        }
     }
    
    //dialogo de grupo nuevo
    protected Dialog onCreateDialog(final String grupo, final Context context) {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        final ListView list = this.getListView();
     	final BaseAdapter la = (BaseAdapter) list.getAdapter();
        builder.setTitle("Borrar grupo");
        builder.setMessage("Confirma que desea borrar el grupo " + grupo + "?");
        builder.setPositiveButton("S", new DialogInterface.OnClickListener() {
        public void onClick(DialogInterface dialog, int which) {
            BDAdaptor bda = new BDAdaptor(context);
            bda.abrir_escritura();
            bda.eliminarGrupo(grupo);
            resultado.remove(grupo);
            la.notifyDataSetChanged();
            bda.cerrar();
            
        }
        });
        builder.setNegativeButton("No", new DialogInterface.OnClickListener() {
        public void onClick(DialogInterface dialog, int which) {
            dialog.cancel();
        }
        });
     
        return builder.create();
    }
    
    //menu de opciones
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.gestion_grupos, menu);
		return true;
	}
	
	//boton volver a lista
    public boolean volverALista(View v) {
    	BDAdaptor bda = new BDAdaptor(this);
		 bda.abrir_escritura();
		 Cursor miCursor = bda.obtenerInicio();
		 int inicio = 0;
		 if(miCursor.moveToFirst()) {
			 inicio = Integer.parseInt(miCursor.getString(0));
		 }
		 bda.cerrar();
		 Intent act;
		 if(inicio == 0) {
			 act = new Intent(this, ListaAlfabetica.class);
			 startActivity(act);
		 } else if(inicio == 1) {
			 act = new Intent(this, ListaGrupos.class);
			 startActivity(act);
		 }
		 return true;
	 }
    
    //boton nuevo grupo
    public boolean nuevoGrupo(final View v) {
    	final EditText textoGrupo = new EditText(this);
    	AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
    	alertDialogBuilder.setView(textoGrupo);
    	alertDialogBuilder.setTitle("Nuevo grupo");
    	final ListView list = this.getListView();
    	final BaseAdapter la = (BaseAdapter) list.getAdapter();
    	alertDialogBuilder
    	.setCancelable(false)
    	.setPositiveButton("OK", new DialogInterface.OnClickListener() {
    	public void onClick(DialogInterface dialog,int id) {
    		String grupo = textoGrupo.getText().toString();
    		if(existeGrupo(grupo)) {
    			Toast toast = Toast.makeText(v.getContext(), "El grupo indicado ya existe.", Toast.LENGTH_LONG);
    	        toast.show();
    	        nuevoGrupo(v);
    		}
    		else if (grupo.isEmpty()) {
    			Toast toast = Toast.makeText(v.getContext(), "Debes indicar el nombre del grupo.", Toast.LENGTH_LONG);
    	        toast.show();
    	        nuevoGrupo(v);
    		}
    		else {
	    		BDAdaptor bda = new BDAdaptor(v.getContext());
	    		bda.abrir_escritura();  
	    		bda.insertarGrupo(textoGrupo.getText().toString());
	    		resultado.add(textoGrupo.getText().toString());
	    		Collections.sort(resultado);
	        	la.notifyDataSetChanged();
	    		bda.cerrar();
    		}
    	}
    	})
    	.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
    	public void onClick(DialogInterface dialog,int id) {
    	dialog.cancel();
    	}
    	});
    	 
    	AlertDialog alertDialog = alertDialogBuilder.create();
    	alertDialog.show();
    	return true;
    }
    
    //comprovar si existe grupo
    private boolean existeGrupo(String grupo) {
    	for(int i = 0; i < this.resultado.size(); i++) {
    		if(grupo.equals(resultado.get(i).toString())) {
    			return true;
    		}
    	}
    	return false;
    }

}
