package com.jose.businessclients;

import android.os.Bundle;
import android.view.ContextMenu;
import android.view.GestureDetector;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.Instrumentation;
import android.app.ListActivity;
import android.database.Cursor;
import android.widget.ArrayAdapter;
import android.widget.Toast;
import com.jose.businessclients.BDAdaptor;

import java.util.ArrayList;
import java.util.Collections;

import android.view.Window;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.GestureDetector.SimpleOnGestureListener;
import android.widget.ListView;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.net.Uri;
import java.util.Calendar;
import android.provider.CalendarContract;
import android.provider.CalendarContract.Events;

public class ListaAlfabetica extends ListActivity{
	
	private ArrayList<String> resultado = new ArrayList<String>();
	private static final int SWIPE_MIN_DISTANCE = 60;
    private static final int SWIPE_MAX_OFF_PATH = 30;
    private static final int SWIPE_THRESHOLD_VELOCITY = 50;
    private GestureDetector gestureDetector;
    View.OnTouchListener gestureListener;
    boolean swipe = false;
	boolean last_down = false;
	boolean click = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        final BDAdaptor bda = new BDAdaptor(this);
        requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
        gestureDetector = new GestureDetector(this, new MyGestureDetector());
        bda.abrir_escritura();
        //comprobar configuracion
        Cursor micursor = bda.obtenerInicio();
        if(micursor.moveToFirst()) {
            String inicioAnterior = micursor.getString(0); 
            bda.modificarInicio(Integer.parseInt(inicioAnterior), 0);
        }
        bda.cerrar();
        bda.abrir_escritura();
        //consultar todos los contactos
        micursor = bda.obtenerTodosLosContactos();
        if (micursor.moveToFirst())
        {
        do {
        resultado.add(micursor.getString(0));
        } while (micursor.moveToNext());
        }
        bda.cerrar();
        ListView lv = this.getListView();
        registerForContextMenu(lv);
        setListAdapter(new ArrayAdapter<String>(this,
                android.R.layout.simple_list_item_1, resultado));
        //touchlistener
        gestureListener = new View.OnTouchListener() {
			
            public boolean onTouch(View v, MotionEvent event) {

            	MotionEvent cancelEvent = MotionEvent.obtain(event);
            	switch (event.getActionMasked()) {
            	case MotionEvent.ACTION_MOVE:
                    cancelEvent = MotionEvent.obtain(event);
                    cancelEvent.setAction(MotionEvent.ACTION_CANCEL);
                        v.onTouchEvent(cancelEvent);
                    last_down = false;
                    gestureDetector.onTouchEvent(event);
                    
                    return true;

            	case MotionEvent.ACTION_DOWN:
            		if(swipe == true || click == true) {
            			return false;
            			
            		} else {
            			last_down = true;
            			gestureDetector.onTouchEvent(event);
            			return false;
            		}
            	case MotionEvent.ACTION_UP:
            		if(last_down == true) {
            			last_down = false;
            			click = true;
            			gestureDetector.onTouchEvent(event);
            			return false;
            		} else if(click == true || swipe == true) {
            			return false;
            		} else {
            			gestureDetector.onTouchEvent(event);
            			event.setAction(MotionEvent.ACTION_DOWN);
            			v.onTouchEvent(event);
            			event.setAction(MotionEvent.ACTION_UP);
            			v.onTouchEvent(event);
            			return true;
            			
            		}
            		
            }
            	return true;

            }
   
            
            };
        getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.barratitulo);
        lv.setOnTouchListener(gestureListener);
    }
    
    //comportamiento al clicar un elemento de la lista, tambin usado para detectar el swipe
    @Override
	protected void onListItemClick(ListView list, View view, int position,
	long id) {
		super.onListItemClick(list, view, position, id);
		BDAdaptor bda = new BDAdaptor(this);
		if(click==true) {
		String seleccionado = list.getItemAtPosition(position).toString();
		Intent act = new Intent(this, MostrarContacto.class);
		act.putExtra("contacto", seleccionado);
     	act.putExtra("origen", "alfabetica");
     	startActivity(act);
		} else if(swipe == true) {
			bda.abrir_escritura();
        	int accion = 0;
        	Cursor miCursor = bda.obtenerAccion();
        	if (miCursor.moveToFirst())
    	    {
    	    	do {
    	    		accion = Integer.parseInt(miCursor.getString(0));
    	    	} while (miCursor.moveToNext());
    	    }
        	bda.cerrar();
        	Intent intent = null;
        	String telefono = null;
        	switch (accion) {
        	case 0:
        		bda.abrir_escritura();
        		miCursor = bda.obtenerTelefono((String) list.getItemAtPosition(position));
        		
        		if (miCursor.moveToFirst())
        	    {
        	    	do {
        	    		telefono = miCursor.getString(1);

        	    	} while (miCursor.moveToNext());
        	    }
        		bda.cerrar();
        	    	if (telefono == null || telefono.equals("")) {
        	    		Toast.makeText(getApplicationContext(), "El usuario no tiene telfono asignado", Toast.LENGTH_LONG).show();
        	    	} else {
        	    		intent = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+telefono));
        	    		startActivity(intent);
        	    	}
        		break;
        	case 1:
        		bda.abrir_escritura();
        		miCursor = bda.obtenerTelefono((String) list.getItemAtPosition(position));
        		if (miCursor.moveToFirst())
        	    {
        	    	do {
        	    		telefono = miCursor.getString(1);
        	    	} while (miCursor.moveToNext());
        	    }
        		bda.cerrar();
        		if(telefono == null || telefono.equals("")) {
        			Toast.makeText(getApplicationContext(), "El usuario no tiene telfono asignado", Toast.LENGTH_LONG).show();
        			return;
        		} else {
        			startActivity(new Intent(Intent.ACTION_VIEW, Uri.fromParts("sms", telefono, null)));
        			break;
        		}
        	case 2:
        		String mail = null;
        		bda.abrir_escritura();
        		miCursor = bda.obtenerContacto((String) list.getItemAtPosition(position));
        		if (miCursor.moveToFirst())
        	    {
        	    	do {
        	    		mail = miCursor.getString(6);
        	    	} while (miCursor.moveToNext());
        	    }
        		bda.cerrar();
        		if(mail == null || mail.equals("")) {
        			Toast.makeText(getApplicationContext(), "El usuario no tiene e-mail asignado", Toast.LENGTH_LONG).show();
        			return;
        		} else {
	        		Intent emailIntent = new Intent(Intent.ACTION_SEND);
	                emailIntent.setData(Uri.parse("mailto:"));
	                emailIntent.putExtra(Intent.EXTRA_EMAIL, mail);
	                emailIntent.setType("message/rfc822");
	                startActivity(Intent.createChooser(emailIntent, "Email "));
	                break;
        		}
        	case 3:
        		String web = null;
        		bda.abrir_escritura();
        		miCursor = bda.obtenerContacto((String) list.getItemAtPosition(position));
        		if (miCursor.moveToFirst())
        	    {
        	    	do {
        	    		web = miCursor.getString(7);
        	    	} while (miCursor.moveToNext());
        	    }
        		bda.cerrar();
        		if(web==null || web.equals("")) {
        			Toast.makeText(getApplicationContext(), "El usuario no tiene web asignada", Toast.LENGTH_LONG).show();
        			return;
        		} else {
	        		intent = new Intent(Intent.ACTION_VIEW);
	        		intent.setData(Uri.parse("http://" + web));
	        		startActivity(intent);
	        		break;
        		}
        	
        	case 4:
        		String direccion = null;
        		String ciudad = null;
        		bda.abrir_escritura();
        		miCursor = bda.obtenerContacto((String) list.getItemAtPosition(position));
        		if (miCursor.moveToFirst())
        	    {
        	    	do {
        	    		ciudad = miCursor.getString(4);
        	    		direccion = miCursor.getString(5);
        	    	} while (miCursor.moveToNext());
        	    }
        		bda.cerrar();
        		
        		if(direccion==null || direccion.equals("")) {
        			Toast.makeText(getApplicationContext(), "El usuario no tiene direccin asignada", Toast.LENGTH_LONG).show();
        			return;
        		} else {
	        		intent = new Intent(Intent.ACTION_VIEW, Uri.parse("https://maps.google.es/maps?q=" + ciudad + ", " + direccion));
	        		startActivity(intent);
	        		break;
        		}
        	
        	case 5:
        		Calendar cal = Calendar.getInstance();
        		  
        		  cal.set(Calendar.DAY_OF_MONTH, 29);
        		  cal.set(Calendar.MONTH, 4);
        		  cal.set(Calendar.YEAR, 2013);
        		  
        		  cal.set(Calendar.HOUR_OF_DAY, 22);
        		  cal.set(Calendar.MINUTE, 45);
        		  
        		  intent = new Intent(Intent.ACTION_EDIT);
        		  intent.setType("vnd.android.cursor.item/event");

        		  intent.putExtra(CalendarContract.EXTRA_EVENT_BEGIN_TIME, cal.getTimeInMillis());
        		  intent.putExtra(CalendarContract.EXTRA_EVENT_END_TIME, cal.getTimeInMillis()+60*60*1000);

        		  intent.putExtra(Events.ALL_DAY, false);
        		  intent.putExtra(Events.TITLE, "Ttulo de vuestro evento");

        		  startActivity(intent);
        		break;
        	}
		}
		last_down = false;
		click = false;
		swipe = false;
		return;
	}

    //menu de opciones
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        CreateOptionsMenu(menu);
        return true;
    }
    
    //accion a realizar al seleccionar un elemento del menu de opciones
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    	Intent act;
        switch (item.getItemId()) {
        case 0:
        	act = new Intent(this, NuevoContacto.class);
        	act.putExtra("origen", "alfabetica");
       	 	startActivity(act);      	 
       	 	return true;
        case 1:
        	act = new Intent(this, ListaGrupos.class);
        	 
        	 startActivity(act);

            return true;
        case 2:
        	act = new Intent(this, GestionGrupos.class);
        	act.putExtra("origen", "alfabetica");
        	startActivity(act);
        	return true;
        case 3:
        	act = new Intent(this, Opciones.class);
        	act.putExtra("origen", "alfabetica");
        	startActivity(act);
        	return true;
        default:
            return super.onOptionsItemSelected(item);
        }
    }
    
    //menu contextual
    public void onCreateContextMenu(ContextMenu menu, View view,
			ContextMenuInfo menuInfo) {
		super.onCreateContextMenu(menu, view, menuInfo);
		AdapterContextMenuInfo info = (AdapterContextMenuInfo)menuInfo;
		String seleccionado = this.getListView().getAdapter().getItem(info.position).toString();
		menu.setHeaderTitle(seleccionado);
		CreateContextMenu(menu);
	}
    
    //configurar menu contextual
    private void CreateContextMenu(Menu menu) {
    	menu.add(0,0,0, "Editar contacto");
    	menu.add(0,1,1, "Borrar contacto");
    }
    
    //accion al seleccionar accion del menu contextual
    public boolean onContextItemSelected(MenuItem item) {
        AdapterContextMenuInfo info = (AdapterContextMenuInfo) item.getMenuInfo();
        Intent act;
        String seleccionado = this.getListView().getAdapter().getItem(info.position).toString();
        switch (item.getItemId()) {
             case 0:
            	 act = new Intent(this, EditarContacto.class);
             	act.putExtra("contacto", seleccionado);
             	act.putExtra("origen", "alfabetica");
            	 	startActivity(act); 
                   return true;
             case 1:
                   onCreateDialog(seleccionado,this).show();
                   return true;
             default:
            	   return super.onContextItemSelected(item);
        }
     }
    
    //configurar menu de opciones
    private void CreateOptionsMenu (Menu menu) {
		MenuItem menu_agregar = menu.add(0, 0, 0, "Agregar contacto");
		{
			menu_agregar.setIcon(android.R.drawable.ic_menu_add);
		}
		MenuItem menu_grupos = menu.add(0, 1, 1, "Mostrar en grupos");
		{
			menu_grupos.setIcon(R.drawable.ic_menu_allfriends);
		}
		MenuItem menu_gestion_grupos = menu.add(0, 2, 2, "Gestionar grupos");
		{
			menu_gestion_grupos.setIcon(android.R.drawable.ic_menu_agenda);
		}
		MenuItem menu_opciones = menu.add(0, 3, 3, "Opciones");
		{
			menu_opciones.setIcon(android.R.drawable.ic_menu_preferences);
		}
	}
    
    //boton nuevo contacto
    public boolean llamarNuevoContacto(View v) {
        
    	Intent act = new Intent(this, NuevoContacto.class);
    	act.putExtra("origen", "alfabetica");
   	 
   	 startActivity(act);
   	 return true;
    }
    
    //dialogo de eliminar contacto
    protected Dialog onCreateDialog(final String contacto, final Context context) {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setTitle("Borrar contacto");
        builder.setMessage("Confirma que desea borrar el contacto " + contacto + "?");
        builder.setPositiveButton("S", new DialogInterface.OnClickListener() {
        public void onClick(DialogInterface dialog, int which) {
            BDAdaptor bda = new BDAdaptor(context);
            bda.abrir_escritura();
            bda.eliminarContacto(contacto);
            bda.cerrar();
            dialog.cancel();
            Intent act = new Intent(context, ListaAlfabetica.class);
            startActivity(act);
            finish();
        }
        });
        builder.setNegativeButton("No", new DialogInterface.OnClickListener() {
        public void onClick(DialogInterface dialog, int which) {
            dialog.cancel();
        }
        });
     
        return builder.create();
    }
    
    //boton opciones
    public boolean botonOpciones(View v) {
    	new Thread(new Runnable() {         
            @Override
            public void run() {
               
                Instrumentation inst = new Instrumentation();
                inst.sendCharacterSync(KeyEvent.KEYCODE_MENU);
                
               
            }   
        }).start();
    	return true;
    }
    
    //detector de swipe
    class MyGestureDetector extends SimpleOnGestureListener {
        @Override
        public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
            try {
                if (Math.abs(e1.getY() - e2.getY()) > SWIPE_MAX_OFF_PATH)
                	return false;
                if(e1.getX() - e2.getX() > SWIPE_MIN_DISTANCE && Math.abs(velocityX) > SWIPE_THRESHOLD_VELOCITY) {
                    swipe = true;
                }  else if (e2.getX() - e1.getX() > SWIPE_MIN_DISTANCE && Math.abs(velocityX) > SWIPE_THRESHOLD_VELOCITY) {
                    swipe = true;
                }
            } catch (Exception e) {
            }
            return true;
        }
       @Override
        public boolean onDown(MotionEvent e) {
    	   
            return true;
        }
       
    }
}
