package com.jose.businessclients;

import android.net.Uri;
import android.os.Bundle;
import android.provider.CalendarContract;
import android.provider.CalendarContract.Events;
import android.app.ExpandableListActivity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.Instrumentation;
import android.view.ContextMenu;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.ExpandableListView;
import android.widget.ExpandableListView.ExpandableListContextMenuInfo;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.Calendar;



import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.view.MotionEvent;
import android.widget.ExpandableListView.OnChildClickListener;
import android.widget.ExpandableListView.OnGroupClickListener;
import android.view.GestureDetector.SimpleOnGestureListener;
import android.view.GestureDetector;


public class ListaGrupos extends ExpandableListActivity implements OnChildClickListener, OnGroupClickListener {
	

	private static final int SWIPE_MIN_DISTANCE = 60;
    private static final int SWIPE_MAX_OFF_PATH = 30;
    private static final int SWIPE_THRESHOLD_VELOCITY = 50;
    private GestureDetector gestureDetector;
    View.OnTouchListener gestureListener;
	private ArrayList<String> groups = new ArrayList<String>();
	private Cursor clients;
	boolean swipe = false;
	boolean last_down = false;
	boolean click = false;
	MotionEvent down_event;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        final BDAdaptor bda = new BDAdaptor(this);
        requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		gestureDetector = new GestureDetector(this, new MyGestureDetector());
		bda.abrir_escritura();
		//obtener configuracion
        Cursor micursor = bda.obtenerInicio();
        if(micursor.moveToFirst()) {
            String inicioAnterior = micursor.getString(0); 
            bda.modificarInicio(Integer.parseInt(inicioAnterior), 1);
        }
        bda.cerrar();
        //obtener grupos
        bda.abrir_escritura();
        micursor = bda.obtenerGrupos();
        if (micursor.moveToFirst())
        {
        do {
        groups.add(micursor.getString(0));
        } while (micursor.moveToNext());
        }
        //obtener contactos
        clients = bda.obtenerTodosLosContactos();
        final ExpandableListAdaptor mi_adaptor = new ExpandableListAdaptor(this, groups, clients);
        setListAdapter(mi_adaptor);
        //swipe listener
		gestureListener = new View.OnTouchListener() {
			
            public boolean onTouch(View v, MotionEvent event) {

            	MotionEvent cancelEvent = MotionEvent.obtain(event);
            	switch (event.getActionMasked()) {
            	case MotionEvent.ACTION_MOVE:
                    cancelEvent = MotionEvent.obtain(event);
                    cancelEvent.setAction(MotionEvent.ACTION_CANCEL);
                        v.onTouchEvent(cancelEvent);
                    last_down = false;
                    gestureDetector.onTouchEvent(event);
                    
                    return true;

            	case MotionEvent.ACTION_DOWN:
            		if(swipe == true || click == true) {
            			return false;
            			
            		} else {
            			last_down = true;
            			down_event = event;
            			gestureDetector.onTouchEvent(event);
            			return false;
            		}
            	case MotionEvent.ACTION_UP:
            		if(last_down == true) {
            			last_down = false;
            			click = true;
            			gestureDetector.onTouchEvent(event);
            			return false;
            		} else if(click == true || swipe == true) {
            			return false;
            		} else {
            			gestureDetector.onTouchEvent(event);
            			event.setAction(MotionEvent.ACTION_DOWN);
            			v.onTouchEvent(event);
            			event.setAction(MotionEvent.ACTION_UP);
            			v.onTouchEvent(event);
            			return true;
            			
            		}
            		
            }
            	cancelEvent.recycle();
            	return true;

            }
   
            
            };
        
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.barratitulo);
        bda.cerrar();
        getExpandableListView().setOnGroupClickListener(this);
        getExpandableListView().setOnTouchListener(gestureListener);
        registerForContextMenu(getExpandableListView());
        
        
	}
	
	//clic en hijo, usado tambin para realizar accin de swipe
	@Override
	public boolean onChildClick(ExpandableListView parent, View v, int groupPosition, int childPosition, long id) {
		super.onChildClick(parent, v, groupPosition, childPosition, id);
		ExpandableListAdaptor ela = (ExpandableListAdaptor) parent.getExpandableListAdapter();
		BDAdaptor bda = new BDAdaptor(this);
		if(click==true) {
			String seleccionado = ela.getChild(groupPosition, childPosition);
			Intent act = new Intent(this, MostrarContacto.class);
			act.putExtra("contacto", seleccionado);
	     	act.putExtra("origen", "alfabetica");
	     	startActivity(act);
		} else if(swipe == true) {
			bda.abrir_escritura();
        	int accion = 0;
        	Cursor miCursor = bda.obtenerAccion();
        	if (miCursor.moveToFirst())
    	    {
    	    	do {
    	    		accion = Integer.parseInt(miCursor.getString(0));
    	    	} while (miCursor.moveToNext());
    	    }
        	bda.cerrar();
        	Intent intent = null;
        	String telefono = null;
        	switch (accion) {
        	case 0:
        		bda.abrir_escritura();
        		miCursor = bda.obtenerTelefono(ela.getChild(groupPosition, childPosition));
        		if (miCursor.moveToFirst())
        	    {
        	    	do {
        	    		telefono = miCursor.getString(1);
        	    	} while (miCursor.moveToNext());
        	    }
        		bda.cerrar();
        		if(telefono==null || telefono.equals("")) {
        			Toast.makeText(getApplicationContext(), "El usuario no tiene telfono asignado", Toast.LENGTH_LONG).show();
        			return false;
        		} else {
	        		intent = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+telefono));
	        		startActivity(intent);
	        		return true;
        		}
        	case 1:
        		bda.abrir_escritura();
        		miCursor = bda.obtenerTelefono(ela.getChild(groupPosition, childPosition));
        		if (miCursor.moveToFirst())
        	    {
        	    	do {
        	    		telefono = miCursor.getString(1);
        	    	} while (miCursor.moveToNext());
        	    }
        		bda.cerrar();
        		if(telefono==null || telefono.equals("")) {
        			Toast.makeText(getApplicationContext(), "El usuario no tiene telfono asignado", Toast.LENGTH_LONG).show();
        			return false;
        		} else {
	        		startActivity(new Intent(Intent.ACTION_VIEW, Uri.fromParts("sms", telefono, null)));
	        		return true;
        		}
        	case 2:
        		String mail = null;
        		bda.abrir_escritura();
        		miCursor = bda.obtenerContacto(ela.getChild(groupPosition, childPosition));
        		if (miCursor.moveToFirst())
        	    {
        	    	do {
        	    		mail = miCursor.getString(6);
        	    	} while (miCursor.moveToNext());
        	    }
        		bda.cerrar();
        		if(mail==null || mail.equals("")) {
        			Toast.makeText(getApplicationContext(), "El usuario no tiene e-mail asignado", Toast.LENGTH_LONG).show();
        			return false;
        		} else {
	        		Intent emailIntent = new Intent(Intent.ACTION_SEND);
	                emailIntent.setData(Uri.parse("mailto:"));
	                emailIntent.putExtra(Intent.EXTRA_EMAIL, mail);
	                emailIntent.setType("message/rfc822");
	                startActivity(Intent.createChooser(emailIntent, "Email "));
	                return true;
        		}
        	case 3:
        		String web = null;
        		bda.abrir_escritura();
        		miCursor = bda.obtenerContacto(ela.getChild(groupPosition, childPosition));
        		if (miCursor.moveToFirst())
        	    {
        	    	do {
        	    		web = miCursor.getString(7);
        	    	} while (miCursor.moveToNext());
        	    }
        		bda.cerrar();
        		if(web==null || web.equals("")) {
        			Toast.makeText(getApplicationContext(), "El usuario no tiene web asignada", Toast.LENGTH_LONG).show();
        			return false;
        		} else {
	        		intent = new Intent(Intent.ACTION_VIEW);
	        		intent.setData(Uri.parse("http://" + web));
	        		startActivity(intent);
	        		return true;
        		}
        	case 4:
        		String direccion = null;
        		String ciudad = null;
        		bda.abrir_escritura();
        		miCursor = bda.obtenerContacto(ela.getChild(groupPosition, childPosition));
        		if (miCursor.moveToFirst())
        	    {
        	    	do {
        	    		ciudad = miCursor.getString(4);
        	    		direccion = miCursor.getString(5);
        	    	} while (miCursor.moveToNext());
        	    }
        		bda.cerrar();
        		if(direccion==null || direccion.equals("")) {
        			Toast.makeText(getApplicationContext(), "El usuario no tiene direccin asignada", Toast.LENGTH_LONG).show();
        			return false;
        		} else {
	        		intent = new Intent(Intent.ACTION_VIEW, Uri.parse("https://maps.google.es/maps?q=" + ciudad + ", " + direccion));
	        		startActivity(intent);
	        		return true;
        		}
        	case 5:
        		Calendar cal = Calendar.getInstance();
        		  
        		  cal.set(Calendar.DAY_OF_MONTH, 29);
        		  cal.set(Calendar.MONTH, 4);
        		  cal.set(Calendar.YEAR, 2013);
        		  
        		  cal.set(Calendar.HOUR_OF_DAY, 22);
        		  cal.set(Calendar.MINUTE, 45);
        		  
        		  intent = new Intent(Intent.ACTION_EDIT);
        		  intent.setType("vnd.android.cursor.item/event");

        		  intent.putExtra(CalendarContract.EXTRA_EVENT_BEGIN_TIME, cal.getTimeInMillis());
        		  intent.putExtra(CalendarContract.EXTRA_EVENT_END_TIME, cal.getTimeInMillis()+60*60*1000);

        		  intent.putExtra(Events.ALL_DAY, false);
        		  intent.putExtra(Events.TITLE, "Ttulo de vuestro evento");

        		  startActivity(intent);
        		return true;
        	}
		}
		last_down = false;
		click = false;
		swipe = false;
		return true;
	}

	//al clicar un grupo
	@Override
	public boolean onGroupClick(ExpandableListView parent, View v, int groupPosition, long id) {
		last_down = false;
		click = false;
		swipe = false;
		if(parent.isGroupExpanded(groupPosition)) {
			parent.collapseGroup(groupPosition);
		} else {
			parent.expandGroup(groupPosition);
		}
		return true;
	}
	
	//menu de opciones
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        CreateOptionsMenu(menu);
        return true;
    }
    
    //al seleccionar un elemento del menu de opciones
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    	Intent act;
        switch (item.getItemId()) {
        case 0:
        	act = new Intent(this, NuevoContacto.class);
        	act.putExtra("origen", "grupos");
       	 
       	 startActivity(act);
       	 return true;
        case 1:
        	 act = new Intent(this, ListaAlfabetica.class);
        	 
        	 startActivity(act);

            return true;
        
        case 2:
        	act = new Intent(this, GestionGrupos.class);
        	act.putExtra("origen", "alfabetica");
        	startActivity(act);
        	return true;
        
        case 3:
        	act = new Intent(this, Opciones.class);
        	act.putExtra("origen", "alfabetica");
        	startActivity(act);
        	return true;
        default:
            return super.onOptionsItemSelected(item);
        }
    }
    
    //menu contextual
    public void onCreateContextMenu(ContextMenu menu, View view,
			ContextMenuInfo menuInfo) {
    	super.onCreateContextMenu(menu, view, menuInfo);
    	swipe = false;
    	click = false;
    	last_down = false;
    	ExpandableListView list = (ExpandableListView) findViewById(R.id.lista_expandible);
    	ExpandableListContextMenuInfo info = (ExpandableListContextMenuInfo)menuInfo;
		groups.remove(groups.size()-1);
		ExpandableListAdaptor listadaptor= new ExpandableListAdaptor(this, groups, clients);
		if(list.getPackedPositionType(info.packedPosition)==list.PACKED_POSITION_TYPE_GROUP) {
			return;
		} else {
			@SuppressWarnings("static-access")
			String seleccionado = listadaptor.getChild(list.getPackedPositionGroup(info.packedPosition),list.getPackedPositionChild(info.packedPosition)).toString();
			menu.setHeaderTitle(seleccionado);
			CreateContextMenu(menu);
		}
	}
    
    //configurar menu contextual
    private void CreateContextMenu(Menu menu) {
    	menu.add(0,0,0, "Editar contacto");
    	menu.add(0,1,1, "Borrar contacto");
    }
    
    //al seleccionar un elemento del menu contextual
    public boolean onContextItemSelected(MenuItem item) {
        ExpandableListView list = (ExpandableListView) findViewById(R.id.lista_expandible);
		ExpandableListContextMenuInfo info = (ExpandableListContextMenuInfo)item.getMenuInfo();
		groups.remove(groups.size()-1);
		ExpandableListAdaptor listadaptor= new ExpandableListAdaptor(this, groups, clients);
		@SuppressWarnings("static-access")
		String seleccionado = listadaptor.getChild(list.getPackedPositionGroup(info.packedPosition),list.getPackedPositionChild(info.packedPosition)).toString();
		Intent act;
        switch (item.getItemId()) {
             case 0:
            	act = new Intent(this, EditarContacto.class);
             	act.putExtra("contacto", seleccionado);
             	act.putExtra("origen", "grupos");
            	 	startActivity(act); 
                   return true;
             case 1:
            	 onCreateDialog(seleccionado,this).show();
                 return true;
             default:
                   return super.onContextItemSelected(item);
        }
     }
    
    //configurar menu de opciones
    private void CreateOptionsMenu (Menu menu) {
		MenuItem menu_agregar = menu.add(0, 0, 0, "Agregar contacto");
		{
			menu_agregar.setIcon(android.R.drawable.ic_menu_add);
		}
		MenuItem menu_grupos = menu.add(0, 1, 1, "Mostrar alfabticamente");
		{
			menu_grupos.setIcon(android.R.drawable.ic_menu_sort_alphabetically);
		}
		MenuItem menu_gestion_grupos = menu.add(0, 2, 2, "Gestionar grupos");
		{
			menu_gestion_grupos.setIcon(android.R.drawable.ic_menu_agenda);
		}
		MenuItem menu_opciones = menu.add(0, 3, 3, "Opciones");
		{
			menu_opciones.setIcon(android.R.drawable.ic_menu_preferences);
		}
	}
    
    
    //boton nuevo contacto
    public boolean llamarNuevoContacto(View v) {
        
    	Intent act = new Intent(this, NuevoContacto.class);
    	act.putExtra("origen", "grupos");
   	 
   	 startActivity(act);
   	 return true;
    }
    
    //dialogo eliminar contacto
    protected Dialog onCreateDialog(final String contacto, final Context context) {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setTitle("Borrar contacto");
        builder.setMessage("Confirma que desea borrar el contacto " + contacto + "?");
        builder.setPositiveButton("S", new DialogInterface.OnClickListener() {
        public void onClick(DialogInterface dialog, int which) {
            BDAdaptor bda = new BDAdaptor(context);
            bda.abrir_escritura();
            Cursor miCursor = bda.obtenerContacto(contacto);
            String grupo = null;
            if(miCursor.moveToFirst()) {
            	grupo = miCursor.getString(1);
            }
            bda.cerrar();
            bda.abrir_escritura();
            bda.eliminarContacto(contacto);
            bda.cerrar();
            dialog.cancel();
            bda.abrir_escritura();
            clients = bda.obtenerTodosLosContactos();
            bda.cerrar();
            
            ExpandableListView  elv = (ExpandableListView) findViewById(R.id.lista_expandible);
            ExpandableListAdaptor ela = (ExpandableListAdaptor) elv.getExpandableListAdapter();
            if(grupo.equals("")) {
            	ela.eliminarCliente(groups.size()-1, contacto);
            } else {
            	ela.eliminarCliente(groups.indexOf(grupo), contacto);
            }
            ela.notifyDataSetChanged();
        }
        });
        builder.setNegativeButton("No", new DialogInterface.OnClickListener() {
        public void onClick(DialogInterface dialog, int which) {
            dialog.cancel();
        }
        });
     
        return builder.create();
    }
    
    //detector de swipe
    class MyGestureDetector extends SimpleOnGestureListener {
        @Override
        public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
            try {
                if (Math.abs(e1.getY() - e2.getY()) > SWIPE_MAX_OFF_PATH)
                	return false;
                if(e1.getX() - e2.getX() > SWIPE_MIN_DISTANCE && Math.abs(velocityX) > SWIPE_THRESHOLD_VELOCITY) {
                    swipe = true;
                }  else if (e2.getX() - e1.getX() > SWIPE_MIN_DISTANCE && Math.abs(velocityX) > SWIPE_THRESHOLD_VELOCITY) {
                    swipe = true;
                }
            } catch (Exception e) {
            }
            return true;
        }
       @Override
        public boolean onDown(MotionEvent e) {
    	   
            return true;
        }
       
    }
    
    //boton opciones
    public boolean botonOpciones(View v) {
    	new Thread(new Runnable() {         
            @Override
            public void run() {
               
                Instrumentation inst = new Instrumentation();
                inst.sendCharacterSync(KeyEvent.KEYCODE_MENU);
                
               
            }   
        }).start();
    	return true;
    }	


}
