package com.jose.businessclients;

import java.util.Calendar;

import android.net.Uri;
import android.os.Bundle;
import android.provider.CalendarContract;
import android.provider.CalendarContract.Events;
import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import android.app.Dialog;
import android.app.AlertDialog;
import android.view.ContextMenu.ContextMenuInfo;
import android.content.DialogInterface;
import android.content.Context;


public class MostrarContacto extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		setContentView(R.layout.activity_mostrar_contacto);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.barratitulo_mostrar_contacto);
		ImageButton opciones = (ImageButton) findViewById(R.id.opciones_contacto);
		registerForContextMenu(opciones);
		//definir textviews
		TextView tipo_movil = (TextView) findViewById(R.id.campo_tipo);
		TextView tipo_provincia = (TextView) findViewById(R.id.campo_provincia);
		TextView ciudad = (TextView) findViewById(R.id.campo_ciudad);
		TextView tipo_grupo = (TextView) findViewById(R.id.campo_grupo);
		TextView nombre = (TextView) findViewById(R.id.campo_nombre);
		TextView empresa  = (TextView) findViewById(R.id.campo_empresa);
		TextView direccion = (TextView) findViewById(R.id.campo_direccion);
		TextView email = (TextView) findViewById(R.id.campo_email);
		TextView web = (TextView) findViewById(R.id.campo_web);
		TextView telefono = (TextView) findViewById(R.id.campo_telefono);
		Bundle bundle = getIntent().getExtras();
		String contacto = bundle.getString("contacto");
		BDAdaptor bda = new BDAdaptor(this);
		//obtener informacin del contacto
		bda.abrir_escritura();
		Cursor cursorContacto = bda.obtenerContacto(contacto);
		if(cursorContacto.moveToFirst()) {
			nombre.setText(cursorContacto.getString(0));
			if(!cursorContacto.getString(2).isEmpty()) {
				empresa.setText(cursorContacto.getString(2));
			} else {
				empresa.setText("No definido");
			}
			if(!cursorContacto.getString(5).isEmpty()) {
				direccion.setText(cursorContacto.getString(5));
				tipo_provincia.setText(cursorContacto.getString(3));
				ciudad.setText(cursorContacto.getString(4));
			} else {
				direccion.setText("No definido");
			}
			if(!cursorContacto.getString(6).isEmpty()) {
				email.setText(cursorContacto.getString(6));
			} else {
				email.setText("No definido");
			}
			if(!cursorContacto.getString(7).isEmpty()) {
				web.setText(cursorContacto.getString(7));
			} else {
				web.setText("No definido");
			}
			if(!cursorContacto.getString(1).isEmpty()) {
				tipo_grupo.setText(cursorContacto.getString(1));
			} else {
				tipo_grupo.setText("Sin grupo");
			}
		}
		//obtener telefono
		Cursor cursorTelefono = bda.obtenerTelefono(contacto);
		if(cursorTelefono.moveToFirst()) {
			telefono.setText(cursorTelefono.getString(1));
			tipo_movil.setText(cursorTelefono.getString(2));
		}
		bda.cerrar();
	}
	
	//menu de opciones
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        CreateOptionsMenu(menu);
        return true;
    }
	
	//al seleccionar un elemento del menu de opciones
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    	Intent act;
    	Bundle bundle = getIntent().getExtras();
    	String origen = bundle.getString("origen");
    	String contacto = bundle.getString("contacto");
        switch (item.getItemId()) {
        case 0:
        	act = new Intent(this, EditarContacto.class);
        	act.putExtra("origen", origen);
        	act.putExtra("contacto", contacto);
       	 	startActivity(act);      	 
       	 	return true;
        case 1:
        	 onCreateDialog(this).show();
        	 return true;
        default:
            return super.onOptionsItemSelected(item);
        }
    }
    
    //configurar menu de opciones
    private void CreateOptionsMenu (Menu menu) {
		MenuItem menu_agregar = menu.add(0, 0, 0, "Editar contacto");
		{
			menu_agregar.setIcon(android.R.drawable.ic_menu_edit);
		}
		MenuItem menu_grupos = menu.add(0, 1, 1, "Eliminar contacto");
		{
			menu_grupos.setIcon(android.R.drawable.ic_menu_delete);
		}
	}
    
    //boton volver a lista
    public boolean volverALista(View v) {
    	BDAdaptor bda = new BDAdaptor(this);
		 bda.abrir_escritura();
		 Cursor miCursor = bda.obtenerInicio();
		 int inicio = 0;
		 if(miCursor.moveToFirst()) {
			 inicio = Integer.parseInt(miCursor.getString(0));
		 }
		 bda.cerrar();
		 Intent act;
		 if(inicio == 0) {
			 act = new Intent(this, ListaAlfabetica.class);
			 startActivity(act);
		 } else if(inicio == 1) {
			 act = new Intent(this, ListaGrupos.class);
			 startActivity(act);
		 }
		 return true;
	 }
    
    //dialogo borrar contacto
    protected Dialog onCreateDialog(final Context context) {
        Bundle bundle = getIntent().getExtras();
        final String contacto = bundle.getString("contacto");
        final String origen = bundle.getString("origen");
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setTitle("Borrar contacto");
        builder.setMessage("Confirma que desea borrar el contacto " + contacto + "?");
        builder.setPositiveButton("S", new DialogInterface.OnClickListener() {
        public void onClick(DialogInterface dialog, int which) {
            BDAdaptor bda = new BDAdaptor(context);
            bda.abrir_escritura();
            bda.eliminarContacto(contacto);
            bda.cerrar();
            dialog.cancel();
            if(origen.equals("alfabetica")) {
            	Intent act = new Intent(context, ListaAlfabetica.class);
            	startActivity(act);
            }
            else {
            	Intent act = new Intent(context, ListaGrupos.class);
            	startActivity(act);
            }
        }
        });
        builder.setNegativeButton("No", new DialogInterface.OnClickListener() {
        public void onClick(DialogInterface dialog, int which) {
            dialog.cancel();
        }
        });
     
        return builder.create();
    }
    
    //boton opciones
    public boolean mostrarOpciones(View v) {
    	ImageButton boton = (ImageButton) findViewById(R.id.opciones_contacto);
    	boton.showContextMenu();
    	return true;
    }
    
    //menu contextual
    public void onCreateContextMenu(ContextMenu menu, View view,
			ContextMenuInfo menuInfo) {
		super.onCreateContextMenu(menu, view, menuInfo);
		menu.setHeaderTitle("Accin a realizar");
		CreateContextMenu(menu);
	}
    
    //configurar menu contextual
    private void CreateContextMenu(Menu menu) {
    	menu.add(0,0,0, "Llamar");
    	menu.add(0,1,1, "Enviar SMS");
    	menu.add(0,2,2, "Enviar e-mail");
    	menu.add(0,3,3, "Abir pgina web");
    	menu.add(0,4,4, "Abrir ubicacin");
    	menu.add(0,5,5, "Nueva cita de calendario");
    	
    }
    
    //al seleccionar un elemento del menu contextual
    public boolean onContextItemSelected(MenuItem item) {
        BDAdaptor bda = new BDAdaptor(this);
        Bundle bundle = getIntent().getExtras();
		String seleccionado = bundle.getString("contacto");
		Cursor miCursor;
		String telefono = null;
		Intent intent;
        switch (item.getItemId()) {
        case 0:
    		bda.abrir_escritura();
    		miCursor = bda.obtenerTelefono(seleccionado);
    		if (miCursor.moveToFirst())
    	    {
    	    	do {
    	    		telefono = miCursor.getString(1);
    	    	} while (miCursor.moveToNext());
    	    }
    		bda.cerrar();
    		if(telefono==null || telefono.equals("")) {
    			Toast.makeText(getApplicationContext(), "El usuario no tiene telfono asignado", Toast.LENGTH_LONG).show();
    			return false;
    		} else {
	    		intent = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+telefono));
	    		startActivity(intent);
	    		return true;
    		}
    	case 1:
    		bda.abrir_escritura();
    		miCursor = bda.obtenerTelefono(seleccionado);
    		if (miCursor.moveToFirst())
    	    {
    	    	do {
    	    		telefono = miCursor.getString(1);
    	    	} while (miCursor.moveToNext());
    	    }
    		bda.cerrar();
    		if(telefono==null || telefono.equals("")) {
    			Toast.makeText(getApplicationContext(), "El usuario no tiene telfono asignado", Toast.LENGTH_LONG).show();
    			return false;
    		} else {
	    		startActivity(new Intent(Intent.ACTION_VIEW, Uri.fromParts("sms", telefono, null)));
	    		return true;
        	}
    	case 2:
    		String mail = null;
    		bda.abrir_escritura();
    		miCursor = bda.obtenerContacto(seleccionado);
    		if (miCursor.moveToFirst())
    	    {
    	    	do {
    	    		mail = miCursor.getString(6);
    	    	} while (miCursor.moveToNext());
    	    }
    		bda.cerrar();
    		if(mail==null || mail.equals("")) {
    			Toast.makeText(getApplicationContext(), "El usuario no tiene e-mail asignado", Toast.LENGTH_LONG).show();
    			return false;
    		} else {
	    		Intent emailIntent = new Intent(Intent.ACTION_SEND);
	            emailIntent.setData(Uri.parse("mailto:"));
	            emailIntent.putExtra(Intent.EXTRA_EMAIL, mail);
	            emailIntent.setType("message/rfc822");
	            startActivity(Intent.createChooser(emailIntent, "Email "));
	            return true;
    		}
    	case 3:
    		String web = null;
    		bda.abrir_escritura();
    		miCursor = bda.obtenerContacto(seleccionado);
    		if (miCursor.moveToFirst())
    	    {
    	    	do {
    	    		web = miCursor.getString(7);
    	    	} while (miCursor.moveToNext());
    	    }
    		bda.cerrar();
    		if(web==null || web.equals("")) {
    			Toast.makeText(getApplicationContext(), "El usuario no tiene web asignada", Toast.LENGTH_LONG).show();
    			return false;
    		} else {
	    		intent = new Intent(Intent.ACTION_VIEW);
	    		intent.setData(Uri.parse("http://" + web));
	    		startActivity(intent);
	    		return true;
    		}
    	
    	case 4:
    		String direccion = null;
    		String ciudad = null;
    		bda.abrir_escritura();
    		miCursor = bda.obtenerContacto(seleccionado);
    		if (miCursor.moveToFirst())
    	    {
    	    	do {
    	    		ciudad = miCursor.getString(4);
    	    		direccion = miCursor.getString(5);
    	    	} while (miCursor.moveToNext());
    	    }
    		bda.cerrar();
    		if(direccion==null || direccion.equals("")) {
    			Toast.makeText(getApplicationContext(), "El usuario no tiene direccin asignada", Toast.LENGTH_LONG).show();
    			return false;
    		} else {
    			intent = new Intent(Intent.ACTION_VIEW, Uri.parse("https://maps.google.es/maps?q=" + direccion));
    			startActivity(intent);
    			return true;
    		}
    	case 5:
    		Calendar cal = Calendar.getInstance();
    		  
    		  cal.set(Calendar.DAY_OF_MONTH, 29);
    		  cal.set(Calendar.MONTH, 4);
    		  cal.set(Calendar.YEAR, 2013);
    		  
    		  cal.set(Calendar.HOUR_OF_DAY, 22);
    		  cal.set(Calendar.MINUTE, 45);
    		  
    		  intent = new Intent(Intent.ACTION_EDIT);
    		  intent.setType("vnd.android.cursor.item/event");

    		  intent.putExtra(CalendarContract.EXTRA_EVENT_BEGIN_TIME, cal.getTimeInMillis());
    		  intent.putExtra(CalendarContract.EXTRA_EVENT_END_TIME, cal.getTimeInMillis()+60*60*1000);

    		  intent.putExtra(Events.ALL_DAY, false);
    		  intent.putExtra(Events.TITLE, "Ttulo de vuestro evento");

    		  startActivity(intent);
    		return true;
        }
        return true;
     }
}
