package com.jose.businessclients;

import android.os.Bundle;
import android.app.Activity;
import android.app.AlertDialog;
import android.database.Cursor;
import android.view.Window;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.AdapterView;
import android.view.View;
import java.util.ArrayList;
import java.util.Collections;

import android.content.DialogInterface;
import android.content.Intent;
import android.widget.TextView;

public class NuevoContacto extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		setContentView(R.layout.activity_nuevo_contacto);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.barratitulo_nuevo_contacto);
		//configuarar spinners
		Spinner tipo_movil = (Spinner) findViewById(R.id.campo_tipo);
		@SuppressWarnings("rawtypes")
		ArrayAdapter adapter_movil = ArrayAdapter.createFromResource(this, R.array.tipos_movil, android.R.layout.simple_spinner_item);
		adapter_movil.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		tipo_movil.setAdapter(adapter_movil);
		tipo_movil.setOnItemSelectedListener(new OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
				
			}
			
			public void onNothingSelected(AdapterView<?> parentView) {
				
			}
		});
		Spinner tipo_provincia = (Spinner) findViewById(R.id.campo_provincia);
		@SuppressWarnings("rawtypes")
		ArrayAdapter adapter_provincia = ArrayAdapter.createFromResource(this, R.array.tipos_provincia, android.R.layout.simple_spinner_item);
		adapter_provincia.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		tipo_provincia.setAdapter(adapter_provincia);
		tipo_provincia.setOnItemSelectedListener(new OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
				
			}
			
			public void onNothingSelected(AdapterView<?> parentView) {
				
			}
		});
		BDAdaptor bda = new BDAdaptor(this);
		final ArrayList<String> groups = new ArrayList<String>();
		//consultar grupos
		bda.abrir_escritura();
		Cursor micursor = bda.obtenerGrupos();
        if (micursor.moveToFirst())
        {
        do {
        groups.add(micursor.getString(0));
        } while (micursor.moveToNext());
        }
        groups.add(0, "Sin grupo");
        groups.add("Nuevo grupo");
        bda.cerrar();
		Spinner tipo_grupo = (Spinner) findViewById(R.id.campo_grupo);
		@SuppressWarnings({ "unchecked", "rawtypes" })
		ArrayAdapter adapter_grupo = new ArrayAdapter(this, android.R.layout.simple_spinner_item, groups);
		adapter_grupo.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		//spinner de grupos
		tipo_grupo.setAdapter(adapter_grupo);
		tipo_grupo.setOnItemSelectedListener(new OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
				if(position == groups.size()-1) {
					onCreateDialog(selectedItemView, groups);
				}
			}
			
			public void onNothingSelected(AdapterView<?> parentView) {
				
			}
		});
		
	}
	
	//dialog para crear nuevo grupo
	protected void onCreateDialog(final View v, final ArrayList<String> groups) {
		 final EditText textoGrupo = new EditText(this);
	    	AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
	    	alertDialogBuilder.setView(textoGrupo);
	    	alertDialogBuilder.setTitle("Nuevo grupo");
	    	alertDialogBuilder
	    	.setCancelable(false)
	    	.setPositiveButton("OK", new DialogInterface.OnClickListener() {
	    	public void onClick(DialogInterface dialog,int id) {
	    		String grupo = textoGrupo.getText().toString();
	    		if(existeGrupo(grupo, groups)) {
	    			Toast toast = Toast.makeText(v.getContext(), "El grupo indicado ya existe.", Toast.LENGTH_LONG);
	    	        toast.show();
	    	        onCreateDialog(v, groups);
	    		}
	    		else if (grupo.isEmpty()) {
	    			Toast toast = Toast.makeText(v.getContext(), "Debes indicar el nombre del grupo.", Toast.LENGTH_LONG);
	    	        toast.show();
	    	        onCreateDialog(v, groups);
	    		}
	    		else {
		    		BDAdaptor bda = new BDAdaptor(v.getContext());
		    		bda.abrir_escritura();  
		    		bda.insertarGrupo(textoGrupo.getText().toString());
		    		groups.add(textoGrupo.getText().toString());
		    		Spinner tipo_grupo = (Spinner) findViewById(R.id.campo_grupo);
		    		bda.cerrar();
		    		groups.remove("Sin grupo");
					groups.remove("Nuevo grupo");
					Collections.sort(groups);
					groups.add(0, "Sin grupo");
					groups.add("Nuevo grupo");
					dialog.cancel();
					tipo_grupo.setSelection(groups.indexOf(textoGrupo.getText().toString()));
					BaseAdapter la = (BaseAdapter) tipo_grupo.getAdapter();
					la.notifyDataSetChanged();
					
	    		}
	    	}
	    	})
	    	.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
	    	public void onClick(DialogInterface dialog,int id) {
	    	Spinner tipo_grupo = (Spinner) findViewById(R.id.campo_grupo);
	    	dialog.cancel();
	    	tipo_grupo.setSelection(0);
	    	BaseAdapter la = (BaseAdapter) tipo_grupo.getAdapter();
			la.notifyDataSetChanged();
	    	}
	    	});
	     
	        alertDialogBuilder.create().show();
	    }
	
	//comprovar si un grupo ya existe
	private boolean existeGrupo(String grupo, ArrayList<String> groups) {
		 for(int i = 0; i < groups.size(); i++) {
	    		if(grupo.equals(groups.get(i).toString())) {
	    			return true;
	    		}
	    	}
	    	return false;
	 }
	
	//boton de volver a la lista
	 public boolean volverALista(View v) {
		 BDAdaptor bda = new BDAdaptor(this);
		 bda.abrir_escritura();
		 Cursor miCursor = bda.obtenerInicio();
		 int inicio = 0;
		 if(miCursor.moveToFirst()) {
			 inicio = Integer.parseInt(miCursor.getString(0));
		 }
		 bda.cerrar();
		 Intent act;
		 if(inicio == 0) {
			 act = new Intent(this, ListaAlfabetica.class);
			 startActivity(act);
		 } else if(inicio == 1) {
			 act = new Intent(this, ListaGrupos.class);
			 startActivity(act);
		 }
		 return true;
	 }
	 
	 //boton guardar contacto
	 public boolean guardarContacto(View v) {
		 
		 Spinner tipo_movil = (Spinner) findViewById(R.id.campo_tipo);
		 Spinner tipo_provincia = (Spinner) findViewById(R.id.campo_provincia);
		 Spinner tipo_grupo = (Spinner) findViewById(R.id.campo_grupo);
		 TextView nombre = (TextView) findViewById(R.id.campo_nombre);
		 TextView empresa  = (TextView) findViewById(R.id.campo_empresa);
		 TextView direccion = (TextView) findViewById(R.id.campo_direccion);
		 TextView email = (TextView) findViewById(R.id.campo_email);
		 TextView web = (TextView) findViewById(R.id.campo_web);
		 TextView telefono = (TextView) findViewById(R.id.campo_telefono);
		 TextView ciudad = (TextView) findViewById(R.id.campo_ciudad);
		 BDAdaptor bda = new BDAdaptor(this);
		 String grupo = tipo_grupo.getSelectedItem().toString();
		 if(nombre.getText().toString().equals("")) {
			 Toast.makeText(getApplicationContext(), "Es necesario indicar un nombre de usuario", Toast.LENGTH_LONG).show();
			 return false;
		 }
		 bda.abrir_escritura();
		 bda.insertarContacto(nombre.getText().toString(), grupo, empresa.getText().toString(), tipo_provincia.getSelectedItem().toString(), ciudad.getText().toString(), direccion.getText().toString(), email.getText().toString(), web.getText().toString());
		 bda.insertarTelefono(telefono.getText().toString(), tipo_movil.getSelectedItem().toString(), nombre.getText().toString());
		 bda.cerrar();
		 Bundle bundle = getIntent().getExtras();
		 Intent act;
		 if(bundle.getString("origen").equals("alfabetica")) {
			 act = new Intent(this, ListaAlfabetica.class);
			 startActivity(act);
		 }
		 else if(bundle.getString("origen").equals("grupos")) {
			 act = new Intent(this, ListaGrupos.class);
			 startActivity(act);
		 }
		 return true;
	 }

}
