package com.jose.businessclients;

import java.util.ArrayList;

import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;

public class Opciones extends ListActivity {
	
	private ArrayList<String> resultado = new ArrayList<String>();
	int valorPrevio;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		rellenarResultado(resultado);
		BDAdaptor bda = new BDAdaptor(this);
		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		String accion = null;
		//consultar accion actual
		bda.abrir_escritura();
	    Cursor micursor = bda.obtenerAccion();
	    if (micursor.moveToFirst())
	    {
	    	do {
	    		accion = micursor.getString(0);
	    	} while (micursor.moveToNext());
	    }
	    int todo = Integer.parseInt(accion);
	    valorPrevio = todo;
	    setListAdapter(new ArrayAdapter<String>(this,
	                android.R.layout.simple_list_item_single_choice, resultado));
	    getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.barratitulo_opciones);
	    bda.cerrar();
	    ListView lv = this.getListView();
	    lv.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
	    lv.setItemChecked(todo, true);
	    registerForContextMenu(lv);
	}

    //configurar lista
    private void rellenarResultado (ArrayList<String> resultado) {
    	resultado.add("Llamar");
    	resultado.add("Enviar SMS");
    	resultado.add("Enviar correo electrnico");
    	resultado.add("Visitar pgina web");
    	resultado.add("Abrir ubicacin");
    	resultado.add("Nueva cita de calendario");
    }
    
    //al pulsar un elemento de la lista
    @Override
	protected void onListItemClick(ListView list, View view, int position,
	long id) {
		super.onListItemClick(list, view, position, id);
		BDAdaptor bda = new BDAdaptor (this);
		bda.abrir_escritura();
		bda.modificarAccion(valorPrevio, position);
		valorPrevio = position;
		bda.cerrar();
	}

	//boton volver a lista
    public boolean volverALista(View v) {
    	BDAdaptor bda = new BDAdaptor(this);
		 bda.abrir_escritura();
		 Cursor miCursor = bda.obtenerInicio();
		 int inicio = 0;
		 if(miCursor.moveToFirst()) {
			 inicio = Integer.parseInt(miCursor.getString(0));
		 }
		 bda.cerrar();
		 Intent act;
		 if(inicio == 0) {
			 act = new Intent(this, ListaAlfabetica.class);
			 startActivity(act);
		 } else if(inicio == 1) {
			 act = new Intent(this, ListaGrupos.class);
			 startActivity(act);
		 }
		 return true;
	 }

}
